
program citations1;

uses
  SysUtils, Classes, FileUtil;

const
  FICHIER = 'citations.dat';

type
  TCitation = record
    texte: array[0..999] of char;
    opus: shortstring;
    page: word;
    clefs: shortstring;
  end;
  
  TFichierCitations = file of TCitation;

procedure Ajouter(const c: TCitation);
var
  f: TFichierCitations;
begin
  AssignFile(f, FICHIER);
  if FileExists(FICHIER) then
    Reset(f)
  else
    Rewrite(f);
  Seek(f, FileSize(f));
  Write(f, c);
  CloseFile(f);
end;

var
  fichiers: TStringList;
  i: integer;
  c: TCitation;

begin
  fichiers := FindAllFiles('res', '*.txt');
  
  for i := 0 to fichiers.Count - 1 do
    with TStringList.Create do
    try
      LoadFromFile(fichiers.strings[i]);
      StrPLCopy(c.texte, strings[0], High(c.texte));
      c.opus := strings[1];
      c.page := word(StrToInt(strings[2]));
      c.clefs := strings[3];
      Ajouter(c);
    finally
      Free;
    end;
end.
