
program citations3;

uses
  SysUtils, Classes, FileUtil;

const
  FICHIER = 'citations.dat';

type
  TCitation = record
    texte: array[0..999] of char;
    opus: shortstring;
    page: word;
    clefs: shortstring;
  end;
  
  TFichierCitations = file of TCitation;

procedure LireTout();
var
  f: TFichierCitations;
  c: TCitation;
begin
  if FileExists(FICHIER) then
  begin
    AssignFile(f, FICHIER);
    Reset(f);
    while not EOF(f) do
    begin
      Write(Format('%0.3d ', [FilePos(f)]));
      Read(f, c);
      WriteLn(c.clefs);
    end;
    CloseFile(f);
  end;
end;

procedure Supprimer(const aIndex: longword);
var
  f: TFichierCitations;
  c: TCitation;
begin
  if FileExists(FICHIER) then
  begin
    AssignFile(f, FICHIER);
    Reset(f);
    
    // Se placer sur le dernier enregistrement
    Seek(f, FileSize(f) - 1);
    // Le lire
    Read(f, c);
    // Se placer sur l'enregistrement à supprimer
    Seek(f, aIndex - 1);
    // Écrire les valeurs lues précédemment
    Write(f, c);
    // Se replacer sur le dernier enregistrement
    Seek(f, FileSize(f) - 1);
    // Tronquer le fichier
    Truncate(f);
    
    CloseFile(f);
  end;
end;

begin
  LireTout();
  Supprimer(1); // Supprimer le premier enregistrement du fichier
  LireTout();
end.
